unit OrgApi;

{ GLOBAL CONSTANTS DEFINITIONS FOR OrgAPI32.dll }

{$DEFINE DynamicLinkDLL}

{$H+} { PChar = AnsiString }

interface

uses
  Windows
{$IFDEF DynamicLinkDLL}
  ,
  SysUtils
{$ENDIF DynamicLinkDLL}
  ;


{ InitOrgAPI loads the OrgAPI32.DLL.
  Call this procedure if you do not want to start with OrgAPIInit.
  OrgAPIInit will load the OrgAPI32.DLL at the first call. }
procedure InitOrgAPI;


type
  EOrganizerError = class(Exception)
  public
    constructor Create(const Msg: string);
  end;


const

{ FBTENTITY }
  FBT_UNKNOWN = 0;
  FBT_MERCURY = 1;
  FBT_FLAME = 2;
  FBT_NOTES = 3;
  FBT_ATTACHMATE = 4;
  FBT_IBMPROFS = 5;

{ FBTPERIODFLAGS }
  FBT_PERIOD_NONE = $0;
  FBT_PERIOD_DONTCONFLICT = $1;
  FBT_PERIOD_PENCILIN = $2;
  FBT_PERIOD_EXCLUDED = $4;

{ ORGAPIRET }
  OA_FAILURE = 0;
  OA_SUCCESS = 1;
  OA_BADPARM = 2;
  OA_FBT_WRONGENTITY = 3;

{ OrgAPIInit }
  OAIF_NONE = $0;
  OAIF_GATEWAYSESSION = $1;
  OAIF_GRAYDIALOGS = $2;
  OAIF_VALIDATE = $4;
  OAIF_NOUI = $8;

{ ORGACL }
{ No access to the file: }
  OACL_NONE = 0;
{ Not used by a stand-alone Organizer file: }
  OACL_FREETIME = 1;
{ Read-only access: }
  OACL_READER = 2;
{ Read and write access. Assistants can schedule meetings in your file and
  change preferences. Assistants cant view or change entries that are
  confidential or change passwords: }
  OACL_ASSISTANT = 3;
{ Not used by a stand-alone Organizer file: }
  OACL_TRUSTEE = 4;
{ Full access levels, including read, write, and customize access.
  Owners can access confidential entries, set or change passwords: }
  OACL_OWNER = 5;


{ OrgAPIRecordOpen }
  OA_RECORD_FIRST = -1;
  OA_RECORD_NEXT = -2;
  OA_RECORD_PREV = -4;
  OA_RECORD_LAST = -5;

{ OrgAPISectionAlphaSearch }
  FIND_FIRST = $1;
  FIND_EXACT = $2;
  FIND_CASESENSITIVE = $4;

{ OrgAPIRecordFindFirst }
  ORGREC_FINDFIRST = $0;
  ORGREC_FINDEXACT = $1;
  ORGREC_CASEINSENSITIVE = $2;

{ OrgAPIFileOpen }
  OA_NOBURSTLOAD = $1;
  OA_NOPRELOADTABLES = $2;
  OA_NOPASSWORDBOX = $4;

{ ORGAPPTFIELDS }
  ORGAPPT_UNIQID = 0;
  ORGAPPT_CONFIDENTIAL = 1;
  ORGAPPT_CATEGORY = 2;
  ORGAPPT_HASAREMINDER = 3;
  ORGAPPT_ISAGROUP = 4;
  ORGAPPT_ALTERNATELINK = 5;
  ORGAPPT_STARTDATE = 6;
  ORGAPPT_ENDDATE = 7;
  ORGAPPT_DESCRIPTION = 8;
  ORGAPPT_REPEAT = 9;
  ORGAPPT_COST = 10;
  ORGAPPT_COSTCODE = 11;
  ORGAPPT_COSTRATE = 12;
  ORGAPPT_ENTITYNUMBER = 13;
  ORGAPPT_TAKESTIME = 14;
  ORGAPPT_PENCILEDIN = 15;
  ORGAPPT_DOUBLEBOOK = 16;

{ ORGTASKFIELDS }
  ORGTASK_UNIQID = 0;
  ORGTASK_CONFIDENTIAL = 1;
  ORGTASK_CATEGORY = 2;
  ORGTASK_HASAREMINDER = 3;
  ORGTASK_ISAGROUP = 4;
  ORGTASK_ALTERNATELINK = 5;
  ORGTASK_STARTDATE = 6;
  ORGTASK_DUEDATE = 7;
  ORGTASK_DESCRIPTION = 8;
  ORGTASK_REPEAT = 9;
  ORGTASK_COST = 10;
  ORGTASK_COSTCODE = 11;
  ORGTASK_COSTRATE = 12;
  ORGTASK_ENTITYNUMBER = 13;
  ORGTASK_TAKESTIME = 14;
  ORGTASK_PRIORITY = 15;
  ORGTASK_COMPLETION = 16;
  ORGTASK_STATUS = 17;

{ ORGANNIVERSARYFIELDS }
  ORGANNIVERSARY_UNIQID = 0;
  ORGANNIVERSARY_CONFIDENTIAL = 1;
  ORGANNIVERSARY_CATEGORY = 2;
  ORGANNIVERSARY_HASAREMINDER = 3;
  ORGANNIVERSARY_ISAGROUP = 4;
  ORGANNIVERSARY_ALTERNATELINK = 5;
  ORGANNIVERSARY_STARTDATE = 6;
  ORGANNIVERSARY_ENDDATE = 7;
  ORGANNIVERSARY_DESCRIPTION = 8;
  ORGANNIVERSARY_REPEAT = 9;
  ORGANNIVERSARY_COST = 10;
  ORGANNIVERSARY_COSTCODE = 11;
  ORGANNIVERSARY_COSTRATE = 12;
  ORGANNIVERSARY_ENTITYNUMBER = 13;
  ORGANNIVERSARY_TAKESTIME = 14;
  ORGANNIVERSARY_MONTH = 15;
  ORGANNIVERSARY_DAY = 16;
  ORGANNIVERSARY_REPEATEDYEARLY = 17;
  ORGANNIVERSARY_ZODIACSIGN = 18;

{ ORGCALLSFIELDS }
  ORGCALL_UNIQID = 0;
  ORGCALL_CONFIDENTIAL = 1;
  ORGCALL_CATEGORY = 2;
  ORGCALL_HASAREMINDER = 3;
  ORGCALL_ISAGROUP = 4;
  ORGCALL_ALTERNATELINK = 5;
  ORGCALL_STARTDATE = 6;
  ORGCALL_ENDDATE = 7;
  ORGCALL_DESCRIPTION = 8;
  ORGCALL_REPEAT = 9;
  ORGCALL_COST = 10;
  ORGCALL_COSTCODE = 11;
  ORGCALL_COSTRATE = 12;
  ORGCALL_ENTITYNUMBER = 13;
  ORGCALL_TAKESTIME = 14;
  ORGCALL_PHONE = 15;
  ORGCALL_FNAME = 16;
  ORGCALL_LNAME = 17;
  ORGCALL_COMPANY = 18;
  ORGCALL_STATUS = 19;
  ORGCALL_DIALMODES = 20;
  ORGCALL_COMPLETED = 21;
  ORGCALL_AREACODE = 22;
  ORGCALL_COUNTRYCODE = 23;
  ORGCALL_USEAREAANDCOUNTRY = 24;
  ORGCALL_EXTENSION = 25;

{ ORGADDRESSFIELDS }
  ORGADDR_UNIQID = 0;
  ORGADDR_CONFIDENTIAL = 1;
  ORGADDR_CATEGORY = 2;
  ORGADDR_HASAREMINDER = 3;
  ORGADDR_ISAGROUP = 4;
  ORGADDR_ALTERNATELINK = 5;
  ORGADDR_CURRENTADDRESS = 6;
  ORGADDR_FNAME = 7;
  ORGADDR_LNAME = 8;
  ORGADDR_TITLE = 9;
  ORGADDR_POSITION = 10;
  ORGADDR_COMPANY = 11;
  ORGADDR_ADDRESS = 12;
  ORGADDR_CITY = 13;
  ORGADDR_STATE = 14;
  ORGADDR_ZIP = 15;
  ORGADDR_COUNTRY = 16;
  ORGADDR_PHONE = 17;
  ORGADDR_EXT = 18;
  ORGADDR_FAX = 19;
  ORGADDR_EMAIL = 20;
  ORGADDR_UNUSED1 = 21;
  ORGADDR_UNUSED2 = 22;
  ORGADDR_NOTES = 23;
  ORGADDR_HOME_SPOUSE = 24;
  ORGADDR_HOME_CHILDREN = 25;
  ORGADDR_HOME_ADDRESS = 26;
  ORGADDR_HOME_CITY = 27;
  ORGADDR_HOME_STATE = 28;
  ORGADDR_HOME_ZIP = 29;
  ORGADDR_HOME_COUNTRY = 30;
  ORGADDR_HOME_PHONE = 31;
  ORGADDR_HOME_EXT = 32;
  ORGADDR_HOME_FAX = 33;
  ORGADDR_HOME_EMAIL = 34;
  ORGADDR_HOME_UNUSED1 = 35;
  ORGADDR_HOME_UNUSED2 = 36;
  ORGADDR_HOME_NOTES = 37;
  ORGADDR_INDEX_SPARE1 = 38;
  ORGADDR_INDEX_LNAME = 39;
  ORGADDR_INDEX_COMPANY = 40;
  ORGADDR_INDEX_SPARE2 = 41;
  ORGADDR_INDEX_CATEGORY = 42;

{ ORGNOTEPADFIELDS }
  ORGNOTEPAD_UNIQID = 0;
  ORGNOTEPAD_CONFIDENTIAL = 1;
  ORGNOTEPAD_CATEGORY = 2;
  ORGNOTEPAD_HASAREMINDER = 3;
  ORGNOTEPAD_ISAGROUP = 4;
  ORGNOTEPAD_ALTERNATELINK = 5;
  ORGNOTEPAD_PAGETITLE = 6;
  ORGNOTEPAD_PAGENOTE = 7;
  ORGNOTEPAD_SEQUENCE = 8;
  ORGNOTEPAD_PAGECOLOR = 9;
  ORGNOTEPAD_PAGESTYLE = 10;
  ORGNOTEPAD_CREATIONDATE = 11;

{ ORGPLANNERFIELDS }
  ORGPLAN_UNIQID = 0;
  ORGPLAN_CONFIDENTIAL = 1;
  ORGPLAN_CATEGORY = 2;
  ORGPLAN_HASAREMINDER = 3;
  ORGPLAN_ISAGROUP = 4;
  ORGPLAN_ALTERNATELINK = 5;
  ORGPLAN_STARTDATE = 6;
  ORGPLAN_ENDDATE = 7;
  ORGPLAN_DESCRIPTION = 8;
  ORGPLAN_REPEAT = 9;
  ORGPLAN_COST = 10;
  ORGPLAN_COSTCODE = 11;
  ORGPLAN_COSTRATE = 12;
  ORGPLAN_ENTITYNUMBER = 13;
  ORGPLAN_TAKESTIME = 14;
  ORGPLAN_ROW = 15;
  ORGPLAN_KEYID = 16;
  ORGPLAN_ZORDER = 17;

{ ORGREMINDERFIELDS }
  ORGREM_UNIQID = 0;
  ORGREM_CONFIDENTIAL = 1;
  ORGREM_TIME = 2;
  ORGREM_GONEOFF = 3;
  ORGREM_OFFSET = 4;
  ORGREM_OFFSETPLACE = 5;
  ORGREM_TUNE = 6;
  ORGREM_MESSAGE = 7;
  ORGREM_LAUNCH = 8;
  ORGREM_DISPLAY = 9;

{ ORGREGINFO }
  ORGREG_NAME = 0;
  ORGREG_COMPANY = 1;
  ORGREG_SERIAL = 2;
  ORGREG_VERSION = 3;
  ORGREG_INSTALLATION = 4;
  ORGREG_NETWORK = 5;
  ORGREG_SCHEDULING = 6;

{ Field Types (ORGFIELDTYPE) }
  ORGAPI_BYTE = $1;
  ORGAPI_WORD = $2;
  ORGAPI_DWORD = $3;
  ORGAPI_VIRTUALFILE = $4;
  ORGAPI_BOOL = $5;
  ORGAPI_COLORREF = $D;
  ORGAPI_UNIQID = $E;
  ORGAPI_LIST = $400;
  ORGAPI_STRING = $6;
  ORGAPI_STRINGLIST = $406;
  ORGAPI_DATETIME = $8;
  ORGAPI_BITMAP = $9;
  ORGAPI_METAFILE = $A;
  ORGAPI_OLE = $B;
  ORGAPI_RTF = $C;
  ORGAPI_VIRFILE2 = $F;

  ORGAPI_STRING_MAXSIZE = $7530;

{ Table Types (ORGAPISecType) }
  ORGAPI_CALENDAR_TYPE = $100;
  ORGAPI_CALENDAR_OPTIONS_TYPE = $101;
  ORGAPI_CALENDAR_CALENDAR_TYPE = $102;
  ORGAPI_PLANNER_TYPE = $200;
  ORGAPI_PLANNER_OPTIONS_TYPE = $201;
  ORGAPI_TODO_TYPE = $300;
  ORGAPI_TODO_OPTIONS_TYPE = $301;
  ORGAPI_ADDRESS_TYPE = $400;
  ORGAPI_ADDRESS_OPTIONS_TYPE = $401;
  ORGAPI_NOTEPAD_TYPE = $500;
  ORGAPI_NOTEPAD_OPTIONS_TYPE = $501;
  ORGAPI_NOTEPAD_CONTENTS_TYPE = $502;
  ORGAPI_FATNOTEPAD_TYPE = $503;
  ORGAPI_RTF_NOTEPAD = $510;
  ORGAPI_ANNIVERSARY_TYPE = $600;
  ORGAPI_ANNIVERSARY_OPTIONS_TYPE = $601;
  ORGAPI_PHONELOG_TYPE = $700;
  ORGAPI_PHONELOG_OPTIONS_TYPE = $701;
  ORGAPI_SCHED_ORIGINATOR_TYPE = $800;
  ORGAPI_SCHED_ATTENDEE_TYPE = $801;
  ORGAPI_SCHEDULE_DEBUG_TYPE = $802;
  ORGAPI_SCHEDULE_OPTIONS_TYPE = $803;

{ Internal IDs: }
  ORGAPI_FILE_TYPE = $FFFFFFF9;
  ORGAPI_SECTIONS_TYPE = $FEFFFFFF;
  ORGAPI_FRONTCOVER_TYPE = $FEFFFFFE;
  ORGAPI_BACKCOVER_TYPE = $FEFFFFFD;
  ORGAPI_DIVIDER_TYPE = $FEFFFFFC;
  ORGAPI_MESSAGEBOX_TYPE = $FEFFFFFB;
  ORGAPI_MESSAGEBOXOPTIONS_TYPE = $FEFFFFFA;
  ORGAPI_IMPEXPMAPPINGS_TYPE = $FEFFFFF9;
  ORGAPI_BOOK_TYPE = $FEFFFFF8;
  ORGAPI_SHOWTHRU_TYPE = $FEFFFFF7;
  ORGAPI_CATEGORY_TYPE = $FEFFFFF6;
  ORGAPI_REMINDER_TYPE = $FEFFFFF5;
  ORGAPI_COSTCODE_TYPE = $FEFFFFF4;
  ORGAPI_COSTCOST_TYPE = $FEFFFFF3;
  ORGAPI_REPEAT_TYPE = $FEFFFFF2;
  ORGAPI_FILTER_TYPE = $FEFFFFF1;
  ORGAPI_USERSETUP_TYPE = $FEFFFFF0;
  ORGAPI_CRONK_TYPE = $FEFFFFEF;

{ Section Heuristic Types }
  HEURISTIC_HAS_CATEGORIES = $1;
  HEURISTIC_IS_DATEBASED = $2;
  HEURISTIC_HIDDEN_SECTION = $4;
  HEURISTIC_INCLUDED_SECTION = $8;
  HEURISTIC_CAN_SHOWTHRU = $10;
  HEURISTIC_CAN_OLE = $20;
  HEURISTIC_CAN_TAKETIME = $40;
  HEURISTIC_ARCHIVEABLE = $80;
  HEURISTIC_CAN_RTF = $100;

{ ErrorValue }
  ORGAPIEV_Success = 0;
  ORGAPIEV_Failure = 1;
  ORGAPIEV_OutOfDisk = 2;
  ORGAPIEV_OutOfLocalMemory = 3;
  ORGAPIEV_OutOfGlobalMemory = 4;
  ORGAPIEV_UserError = 5;
  ORGAPIEV_GDIError = 6;
  ORGAPIEV_FileLocked = 7;
  ORGAPIEV_RecordLocked = 8;
  ORGAPIEV_BadParms = 9;
  ORGAPIEV_Cancel = 10;
  ORGAPIEV_Retry = 11;
  ORGAPIEV_Abort = 12;
  ORGAPIEV_UserTerminatedProcess = 13;
  ORGAPIEV_AssertionFailure = 14;
  ORGAPIEV_StageFailure = 15;
  ORGAPIEV_FileCreationError = 16;
  ORGAPIEV_ClipboardAlreadyOpen = 17;
  ORGAPIEV_NoFile = 18;
  ORGAPIEV_IntegrityFailure = 19;
  ORGAPIEV_FileExists = 20;
  ORGAPIEV_OSError = 21;
  ORGAPIEV_ForceOSError = 22;
  ORGAPIEV_SeekFailure = 23;
  ORGAPIEV_ReadFailure = 24;
  ORGAPIEV_WriteFailure = 25;
  ORGAPIEV_MediaFailure = 26;
  ORGAPIEV_FreeListFailure = 27;
  ORGAPIEV_YearRange = 28;
  ORGAPIEV_MonthRange = 29;
  ORGAPIEV_DayRange = 30;
  ORGAPIEV_HourRange = 31;
  ORGAPIEV_MinuteRange = 32;
  ORGAPIEV_StructSizeError = 33;
  ORGAPIEV_StructPaddingError = 34;
  ORGAPIEV_StructMemberMisAligned = 35;
  ORGAPIEV_StructMemberCountError = 36;
  ORGAPIEV_KernelError = 37;
  ORGAPIEV_ExecuteError = 38;
  ORGAPIEV_BadDataPtr = 39;
  ORGAPIEV_BadCodePtr = 40;
  ORGAPIEV_StringNonExistant = 41;
  ORGAPIEV_NotVirtualFile = 42;
  ORGAPIEV_NoTable = 43;
  ORGAPIEV_AccessViolation = 44;
  ORGAPIEV_BadID = 45;
  ORGAPIEV_ReadPastEOF = 46;
  ORGAPIEV_FieldNameExists = 47;
  ORGAPIEV_NetworkDirectoryError = 48;
  ORGAPIEV_NetworkTransportError = 49;
  ORGAPIEV_NetworkNetDLLError = 50;
  ORGAPIEV_EndOfTable = 51;
  ORGAPIEV_InvalidVirtualFile = 52;
  ORGAPIEV_CommDlgError = 53;
  ORGAPIEV_NoNamedFile = 54;
  ORGAPIEV_BadMessage = 55;
  ORGAPIEV_Timeout = 56;
  ORGAPIEV_UnexpectedCommError = 57;
  ORGAPIEV_BadOrs = 58;
  ORGAPIEV_DuplicateValueInField = 59;
  ORGAPIEV_ForcedFailure = 60;
  ORGAPIEV_NotLocked = 61;
  ORGAPIEV_GPFault = 62;
  ORGAPIEV_Organizer1File = 63;
  ORGAPIEV_UserBreak = 64;
  ORGAPIEV_DivideByZero = 65;
  ORGAPIEV_FreetimeError = 66;
  ORGAPIEV_SecondRange = 67;
  ORGAPIEV_InvalidPlatformFile = 68;
  ORGAPIEV_ListBroken = 69;
  ORGAPIEV_TreeBroken = 70;
  ORGAPIEV_PrivateError = 71;
  ORGAPIEV_AlreadyInvited = 72;
  ORGAPIEV_StackOverrun = 73;
  ORGAPIEV_BadDIB = 74;
  ORGAPIEV_BadMetafile = 75;
  ORGAPIEV_PrinterError = 76;
  ORGAPIEV_RegDBError = 77;
  ORGAPIEV_NoPrinterConnected = 78;
  ORGAPIEV_IncomingCall = 79;
  ORGAPIEV_BufferTooSmall = 80;
  ORGAPIEV_WriteProtect = 81;
  ORGAPIEV_NetworkAccessDenied = 82;
  ORGAPIEV_LinkSelf = 83;
  ORGAPIEV_LinkAlready = 84;
  ORGAPIEV_RemoteDelete = 85;
  ORGAPIEV_Warning = 86;
  ORGAPIEV_TableExists = 87;
  ORGAPIEV_Org10FileCorrupt = 88;
  ORGAPIEV_AccessDenied = 89;
  ORGAPIEV_BadPath = 90;
  ORGAPIEV_BufferNotLocked = 91;
  ORGAPIEV_TableDeleted = 92;
  ORGAPIEV_BadInstall = 93;
  ORGAPIEV_InvalidInput = 94;
  ORGAPIEV_ODBCError = 95;
  ORGAPIEV_FieldOverflow = 96;
  ORGAPIEV_DDEMLError = 97;
  ORGAPIEV_NotSchedulingFile = 98;
  ORGAPIEV_BadPassword = 99;
  ORGAPIEV_CriticalFault = 100;
  ORGAPIEV_OutOfLuck = 101;
  ORGAPIEV_NoSchema = 102;
  ORGAPIEV_WrongMetafileFormat = 103;
  ORGAPIEV_WrongBackupFilePath = 104;
  ORGAPIEV_OLECantCreateObject = 105;
  ORGAPIEV_OLEPasteSpecialFailed = 106;
  ORGAPIEV_OLEPasteLinkFailed = 107;
  ORGAPIEV_OLELinksCannotBeInitialized = 108;
  ORGAPIEV_OLEUpdateLinksFailed = 109;
  ORGAPIEV_OLELinkSourceCannotBeOpened = 110;
  ORGAPIEV_OLEManageLinksFailed = 111;
  ORGAPIEV_OLEObjectCannotBeAccessed = 112;
  ORGAPIEV_OLEObjectCannotBeLoaded = 113;
  ORGAPIEV_OLEHandlersCannotbeInitialized = 114;
  ORGAPIEV_OLECancelLinkFailed = 115;
  ORGAPIEV_OLEObjectSaveFailed = 116;

{ Organizer General Data Types (Structures) }

type

  HORG_Session = Longint;
  HORG_File = Longint;
  HORG_Section = Longint;
  HORG_Record = Longint;

  PBoolean = ^LongBool;
  PLongint = ^Longint;

  ORGAPIRET = Longint;
  ORGAPISecType = Longint;
  ORGFieldType = Longint;

  PSTRLST = PChar; {
You must follow specific rules to format PSTRLST (stringlist) fields with the
Organizer API datatype creation functions. Each Organizer datatype creation
function has a structure that defines its fields. The Category field
requires 2 NULL-terminating bytes. For example, to enter multiple categories
for a record, fill the input field with NULL-terminated ASCII strings followed
by a field-terminating #0 (in other words, Category1 NULL Category2 NULL . . .
Categoryn  NULL NULL).
For example, to insert the multiple category ABD,DEF code as follows
(using hexadecimal and ASCII values):
Hex	41	42	43	0	44	45	46	0	0
ASCII	A	B	C	#0	D	E	F	#0	#0
The total field length including the two NULLs at the end
cannot exceed 128 bytes.
}


  TORGSECTIONCLASS = record
    UserName: PChar;
    InternalName: PChar;
    Section: Longint;
    Heuristics: Longint;
  end;
  PORGSECTIONCLASS = ^TORGSECTIONCLASS;
{ The default UserName and InternalName for Public sections are:
  Address, Anniversary, Calendar, Calls, Planner, NotePad, and To Do. }

  TORGUNIQID = record
    UniqID: Longint;
    Random: Longint;
  end;

  TORGCOLOR = record
    Red: Byte;
    Green: Byte;
    Blue: Byte;
  end;

  TORGDATETIME = record
    Year: Integer;
    Month: Byte;
    Day: Byte;
    Hour: Byte;
    Minute: Byte;
    Second: Byte;
    GMTOffset: Byte;
  end;
  PORGDATETIME = ^TORGDATETIME;

{ Record Insert Data Types }

  TORGADDRESS = record
    Title: PChar;
    FName: PChar;
    LName: PChar;
    Position: PChar;
    Company: PChar;
    Address: PChar;
    City: PChar;
    State: PChar;
    Zip: PChar;
    Country: PChar;
    Phone: PChar;
    Ext: PChar;
    Fax: PChar;
    Email: PChar;
    Unused1: PChar;
    Unused2: PChar;
    Notes: PChar;
    HomeSpouse: PChar;
    HomeChildren: PChar;
    HomeAddress: PChar;
    HomeCity: PChar;
    HomeState: PChar;
    HomeZip: PChar;
    HomeCountry: PChar;
    HomePhone: PChar;
    HomeExt: PChar;
    HomeFax: PChar;
    HomeEmail: PChar;
    HomeUnused1: PChar;
    HomeUnused2: PChar;
    HomeNotes: PChar;
    Category: PSTRLST;           { PChar }
    lpfConfidential: PBoolean;   { Pointer to Boolean }
  end;

  TORGANNIVERSARY = record
    Description: PChar;
    lpDate: PORGDATETIME;        { Pointer to TORGDATETIME }
    lpdwMonth: PLongint;         { Pointer to Longint variable }
    lpdwDay: PLongint;           { Pointer to Longint variable }
    lpfRepeatedYearly: PBoolean; { Pointer to Boolean }
    Category: PSTRLST;           { StringList }
    CostCode: PChar;
    CustomerCode: PChar;
    lpfConfidential: PBoolean;   { Pointer to Boolean }
  end;

  TORGAPPOINTMENT = record
    lpdtStart: PORGDATETIME;     { Pointer to TORGDATETIME }
    lpdtEnd: PORGDATETIME;       { Pointer to TORGDATETIME }
    Description: PChar;
    Category: PSTRLST;           { StringList }
    CostCode: PChar;
    CustomerCode: PChar;
    lpfConfidential: PBoolean;   { Pointer to Boolean }
  end;

  TORGCALLS = record
    lpdtDate: PORGDATETIME;      { Pointer to TORGDATETIME }
    lpdwDuration: PLongint;      { Pointer to Longint variable }
    FName: PChar;
    LName: PChar;
    Company: PChar;
    Phone: PChar;
    Description: PChar;
    Category: PSTRLST;           { StringList }
    CostCode: PChar;
    CustomerCode: PChar;
    lpfConfidential: PBoolean;   { Pointer to Boolean }
  end;

  TORGNOTEPAD = record
    PageTitle: PChar;
    PageNote: PChar;         { Can be RTF or plain PChar }
    Category: PSTRLST;       { StringList }
    lpfConfidential: PBoolean;
  end;

  TORGPLANNER = record
    Notes: PChar;
    Category: PSTRLST;           { StringList }
    lpdwRow: PLongint;           { Pointer to Longint;variable }
    lpdwKeyID: PLongint;         { Pointer to Longint;variable }
    lpdtStartDate: PORGDATETIME; { Pointer to TORGDATETIME }
    lpdtEndDate: PORGDATETIME;   { Pointer to TORGDATETIME }
    CostCode: PChar;
    CustomerCode: PChar;
    lpfConfidential: PBoolean;   { Pointer to Boolean }
  end;

  TORGREMINDER = record
    lpdtTime: PORGDATETIME;      { Pointer to TORGDATETIME }
    Offset: Longint;             { Longint (not a pointer) }
    BeforeAfter: Longint;        { Longint (not a pointer) }
    Tune: PChar;
    Message: PChar;
    Display: Boolean;            { Boolean (not a pointer) }
  end;

  TORGTASK = record
    Description: PChar;
    lpdtStart: PORGDATETIME;     { Pointer to TORGDATETIME }
    lpdtDue: PORGDATETIME;       { Pointer to TORGDATETIME }
    lpdwStatus: PLongint;        { Pointer to Longint;variable }
    Category: PSTRLST;           { StringList }
    CostCode: PChar;
    CustomerCode: PChar;
    lpfConfidential: PBoolean;   { Pointer to Boolean }
  end;




{ OrgAPI Function definitions }


{$IFDEF DynamicLinkDLL}

TOrgAPIInit = function (
  hWndForm: HWND; Zero1, Zero2, Zero3: Integer;
  ContainerPath, Name, Password: PChar; ApiInitFlags: Integer;
  var Err: Integer): HORG_Session;
  stdcall;

TOrgAPITerm = function (
  hOrgAPI: HORG_Session): ORGAPIRET;
  stdcall;


{ Organizer File Routines }

TOrgAPIFileOpen = function (
  hOrgAPI: HORG_Session; hWndForm: HWND;
  Name, Password: PChar; OrgAccessLevel: Integer;
  OrgOpenFlag: Integer): HORG_File;
  stdcall;

TOrgAPIFileClose = function (
  hOrgFile: HORG_File): ORGAPIRET;
  stdcall;

TOrgAPIFileGetPrivilege = function (
  hOrgFile: HORG_File): Longint;
  stdcall;

TOrgAPIDBGetSingleUser = function (
  hOrgFile: HORG_File;
  var fBool: Boolean): ORGAPIRET;
  stdcall;

TOrgAPIDBSetSingleUser = function (
  hOrgFile: HORG_File; fBool: Boolean): ORGAPIRET;
  stdcall;

TOrgAPIEnumerateSectionsAlt = function (
  hOrgFile: HORG_File;
  var TableNumber: Integer; TableName: PChar; LenTableName: Integer): ORGAPIRET;
  stdcall;


{ Organizer Section Routines }

TOrgAPISectionOpen = function (
  hOrgFile: HORG_File;
  SectionName: PChar): HORG_Section;
  stdcall;

TOrgAPISectionClose = function (
  hOrgSect: HORG_Section): ORGAPIRET;
  stdcall;

TOrgAPISectionClass = function (
  hOrgFile: HORG_File;
  var SectionClassArray: TORGSECTIONCLASS; var One: Integer): Integer;
  stdcall;
{ One: Elements of the array passed. Initial value = 1.
  return: -1 Function failed.
           0 Call completed succesfully
           1 Call completed succesfully and there are more public sections. }

TOrgAPISectionGetPrivilege = function (
  hOrgSect: HORG_Section): Longint;
  stdcall;

TOrgAPISectionType = function (
  hOrgSect: HORG_Section): ORGAPISecType;
  stdcall;

TOrgAPISectionRecordCount = function (
  hOrgSect: HORG_Section): Longint;
  stdcall;

TOrgAPISectionAlphaSearchAlt = function (
  hOrgSect: HORG_Section;
  lpSearchString: PChar; OrgFindFlags: Integer; var lpdwRecPos: Integer;
  var lpuiFieldNum: Integer): ORGAPIRET;
  stdcall;

TOrgAPIIsUNIQIDDeleted = function (
  hOrgSect: HORG_Section;
  var RecordUniqID: TORGUNIQID; var fDeleted: Boolean): ORGAPIRET;
  stdcall;


{ Organizer Record Routines }

{ Returns a Handle to a Record (HORG_Record): }

TOrgAPIRecordOpen = function (
  hOrgSect: HORG_Section;
  RecordPosition: Integer): HORG_Record;
  stdcall;

TOrgAPIRecordFindFirst = function (
  hOrgSect: HORG_Section; FieldNumber: Integer;
  UserData: Pointer; FindFlags: Integer): HORG_Record;
  stdcall;

TOrgAPIRecordFindNext = function (
  hOrgSect: HORG_Section;
  FieldNumber: Integer): ORGAPIRET;
  stdcall;

TOrgAPIRecordOpenByUniqID = function (
  hOrgSect: HORG_Section;
  var RecordUniqID: TORGUNIQID): HORG_Record;
  stdcall;

TOrgAPIAddressInsert = function (
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecAddr: TORGADDRESS): HORG_Record;
  stdcall;

TOrgAPIAlarmInsert = function (
  hOrgFile: HORG_File; hOrgRec: HORG_Record;
  var RecAlarm: TORGREMINDER): HORG_Record;
  stdcall;

TOrgAPIAnniversaryInsert = function (
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecAnniv: TORGANNIVERSARY): HORG_Record;
  stdcall;

TOrgAPIAppointmentInsert = function (
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecAppt: TORGAPPOINTMENT): HORG_Record;
  stdcall;

TOrgAPICallInsert = function (
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecCall: TORGCALLS): HORG_Record;
  stdcall;

TOrgAPINotePadInsert = function (
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecNote: TORGNOTEPAD): HORG_Record;
  stdcall;

TOrgAPIPlannerInsert = function (
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecPlan: TORGPLANNER): HORG_Record;
  stdcall;

TOrgAPITaskInsert = function (
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecTask: TORGTASK): HORG_Record;
  stdcall;


{ Returns a ORGAPIRET: }

TOrgAPIRecordClose = function (
  hOrgRec: HORG_Record): ORGAPIRET;
  stdcall;

TOrgAPIRecordDelete = function (
  hOrgRec: HORG_Record): ORGAPIRET;
  stdcall;

TOrgAPIRecordLinked = function (
  hOrgRec: HORG_Record): Longint;
  stdcall;

TOrgAPIRecordPosition = function (
  hOrgRec: HORG_Record): Longint;
  stdcall;

TOrgAPIAlarmGetAlarmUniqID = function (
  hOrgRec: HORG_Record;
  var AlarmUniqID: TORGUNIQID): ORGAPIRET;
  stdcall;

TOrgAPIAlarmGetHost = function (
  hOrgRec: HORG_Record; HostSectName: PChar;
  LenHostSectName: Integer; var RecordUniqID: TORGUNIQID): ORGAPIRET;
  stdcall;


{ Organizer Field Routines }

TOrgAPIFieldEnumAlt = function (
  hOrgSect: HORG_Section; var FieldNumber: Integer;
  FieldName: PChar; LenFieldName: Integer): ORGAPIRET;
  stdcall;

TOrgAPIFieldGetFieldCount = function (
  hOrgSect: HORG_Section): Longint;
  stdcall;

TOrgAPIFieldGet = function (
  hOrgRec: HORG_Record; FieldNumber: Integer): Pointer;
  stdcall;

TOrgAPIFieldGetFieldType = function (
  hOrgSect: HORG_Section;
  FieldNumber: Integer): ORGFieldType;
  stdcall;

TOrgAPIFieldIsIndexed = function (
  hOrgSect: HORG_Section;
  FieldNumber: Integer): Longint;
  stdcall;

TOrgAPIFieldUpdate = function (
  hOrgRec: HORG_Record; FieldNumber: Integer;
  FieldSize: Integer; var UserData: Pointer): ORGAPIRET;
  stdcall;


{ Organizer Error & Integer Message Routines }

TOrgAPIVersion = function (
  InfoBuffer: PChar; LenInfoBuffer: Longint): ORGAPIRET;
  stdcall;

TOrgAPIGetRegInfo = function (
  RegInfoNum: Integer; InfoBuffer: PChar;
  LenInfoBuffer: Integer): ORGAPIRET;
  stdcall;

TOrgAPIUIHandleErrorAlt = procedure (
  hOrgAPI: HORG_Session; InfoBuffer: PChar;
  LenInfoBuffer: Integer);
  stdcall;

TOrgAPIScriptAddr = function (
  var AnyType: Pointer): ORGAPIRET;
  stdcall;

TOrgAPIStringListLength = function (
  Pointer2StringList: Pointer): Longint;
  stdcall;

TOrgAPIGetErrorCode = function
  : Longint;
  stdcall;


var
  OrgAPIInit: TOrgAPIInit;
  OrgAPITerm: TOrgAPITerm;
  OrgAPIFileOpen: TOrgAPIFileOpen;
  OrgAPIFileClose: TOrgAPIFileClose;
  OrgAPIFileGetPrivilege: TOrgAPIFileGetPrivilege;
  OrgAPIDBGetSingleUser: TOrgAPIDBGetSingleUser;
  OrgAPIDBSetSingleUser: TOrgAPIDBSetSingleUser;
  OrgAPIEnumerateSectionsAlt: TOrgAPIEnumerateSectionsAlt;
  OrgAPISectionOpen: TOrgAPISectionOpen;
  OrgAPISectionClose: TOrgAPISectionClose;
  OrgAPISectionClass: TOrgAPISectionClass;
  OrgAPISectionGetPrivilege: TOrgAPISectionGetPrivilege;
  OrgAPISectionType: TOrgAPISectionType;
  OrgAPISectionRecordCount: TOrgAPISectionRecordCount;
  OrgAPISectionAlphaSearchAlt: TOrgAPISectionAlphaSearchAlt;
  OrgAPIIsUNIQIDDeleted: TOrgAPIIsUNIQIDDeleted;
  OrgAPIRecordOpen: TOrgAPIRecordOpen;
  OrgAPIRecordFindFirst: TOrgAPIRecordFindFirst;
  OrgAPIRecordFindNext: TOrgAPIRecordFindNext;
  OrgAPIRecordOpenByUniqID: TOrgAPIRecordOpenByUniqID;
  OrgAPIAddressInsert: TOrgAPIAddressInsert;
  OrgAPIAlarmInsert: TOrgAPIAlarmInsert;
  OrgAPIAnniversaryInsert: TOrgAPIAnniversaryInsert;
  OrgAPIAppointmentInsert: TOrgAPIAppointmentInsert;
  OrgAPICallInsert: TOrgAPICallInsert;
  OrgAPINotePadInsert: TOrgAPINotePadInsert;
  OrgAPIPlannerInsert: TOrgAPIPlannerInsert;
  OrgAPITaskInsert: TOrgAPITaskInsert;
  OrgAPIRecordClose: TOrgAPIRecordClose;
  OrgAPIRecordDelete: TOrgAPIRecordDelete;
  OrgAPIRecordLinked: TOrgAPIRecordLinked;
  OrgAPIRecordPosition: TOrgAPIRecordPosition;
  OrgAPIAlarmGetAlarmUniqID: TOrgAPIAlarmGetAlarmUniqID;
  OrgAPIAlarmGetHost: TOrgAPIAlarmGetHost;
  OrgAPIFieldEnumAlt: TOrgAPIFieldEnumAlt;
  OrgAPIFieldGetFieldCount: TOrgAPIFieldGetFieldCount;
  OrgAPIFieldGet: TOrgAPIFieldGet;
  OrgAPIFieldGetFieldType: TOrgAPIFieldGetFieldType;
  OrgAPIFieldIsIndexed: TOrgAPIFieldIsIndexed;
  OrgAPIFieldUpdate: TOrgAPIFieldUpdate;
  OrgAPIVersion: TOrgAPIVersion;
  OrgAPIGetRegInfo: TOrgAPIGetRegInfo;
  OrgAPIUIHandleErrorAlt: TOrgAPIUIHandleErrorAlt;
  OrgAPIScriptAddr: TOrgAPIScriptAddr;
  OrgAPIStringListLength: TOrgAPIStringListLength;
  OrgAPIGetErrorCode: TOrgAPIGetErrorCode;

{$ELSE DynamicLinkDLL ------------------------------------------------------- }


{ Organizer Session Routines }


function OrgAPIInit(hWndForm: HWND; Zero1, Zero2, Zero3: Integer;
  ContainerPath, Name, Password: PChar; ApiInitFlags: Integer;
  var Err: Integer): HORG_Session;
  stdcall;

function OrgAPITerm(hOrgAPI: HORG_Session): ORGAPIRET;
  stdcall;


{ Organizer File Routines }

function OrgAPIFileOpen(
  hOrgAPI: HORG_Session; hWndForm: HWND;
  Name, Password: PChar; OrgAccessLevel: Integer;
  OrgOpenFlag: Integer): HORG_File;
  stdcall;

function OrgAPIFileClose(
  hOrgFile: HORG_File): ORGAPIRET;
  stdcall;

function OrgAPIFileGetPrivilege(
  hOrgFile: HORG_File): Longint;
  stdcall;

function OrgAPIDBGetSingleUser(
  hOrgFile: HORG_File;
  var fBool: Boolean): ORGAPIRET;
  stdcall;

function OrgAPIDBSetSingleUser(
  hOrgFile: HORG_File; fBool: Boolean): ORGAPIRET;
  stdcall;

function OrgAPIEnumerateSectionsAlt(
  hOrgFile: HORG_File;
  var TableNumber: Integer; TableName: PChar; LenTableName: Integer): ORGAPIRET;
  stdcall;


{ Organizer Section Routines }

function OrgAPISectionOpen(
  hOrgFile: HORG_File;
  SectionName: PChar): HORG_Section;
  stdcall;

function OrgAPISectionClose(
  hOrgSect: HORG_Section): ORGAPIRET;
  stdcall;

function OrgAPISectionClass(
  hOrgFile: HORG_File;
  var SectionClassArray: TORGSECTIONCLASS; var One: Integer): Integer;
  stdcall;
{ One: Elements of the array passed. Initial value = 1.
  return: -1 Function failed.
           0 Call completed succesfully
           1 Call completed succesfully and there are more public sections. }

function OrgAPISectionGetPrivilege(
  hOrgSect: HORG_Section): Longint;
  stdcall;

function OrgAPISectionType(
  hOrgSect: HORG_Section): ORGAPISecType;
  stdcall;

function OrgAPISectionRecordCount(
  hOrgSect: HORG_Section): Longint;
  stdcall;

function OrgAPISectionAlphaSearchAlt(
  hOrgSect: HORG_Section;
  lpSearchString: PChar; OrgFindFlags: Integer; var lpdwRecPos: Integer;
  var lpuiFieldNum: Integer): ORGAPIRET;
  stdcall;

function OrgAPIIsUNIQIDDeleted(
  hOrgSect: HORG_Section;
  var RecordUniqID: TORGUNIQID; var fDeleted: Boolean): ORGAPIRET;
  stdcall;


{ Organizer Record Routines }

{ Returns a Handle to a Record (HORG_Record): }

function OrgAPIRecordOpen(
  hOrgSect: HORG_Section;
  RecordPosition: Integer): HORG_Record;
  stdcall;

function OrgAPIRecordFindFirst(
  hOrgSect: HORG_Section; FieldNumber: Integer;
  UserData: Pointer; FindFlags: Integer): HORG_Record;
  stdcall;

function OrgAPIRecordFindNext(
  hOrgSect: HORG_Section;
  FieldNumber: Integer): ORGAPIRET;
  stdcall;

function OrgAPIRecordOpenByUniqID(
  hOrgSect: HORG_Section;
  var RecordUniqID: TORGUNIQID): HORG_Record;
  stdcall;

function OrgAPIAddressInsert(
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecAddr: TORGADDRESS): HORG_Record;
  stdcall;

function OrgAPIAlarmInsert(
  hOrgFile: HORG_File; hOrgRec: HORG_Record;
  var RecAlarm: TORGREMINDER): HORG_Record;
  stdcall;

function OrgAPIAnniversaryInsert(
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecAnniv: TORGANNIVERSARY): HORG_Record;
  stdcall;

function OrgAPIAppointmentInsert(
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecAppt: TORGAPPOINTMENT): HORG_Record;
  stdcall;

function OrgAPICallInsert(
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecCall: TORGCALLS): HORG_Record;
  stdcall;

function OrgAPINotePadInsert(
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecNote: TORGNOTEPAD): HORG_Record;
  stdcall;

function OrgAPIPlannerInsert(
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecPlan: TORGPLANNER): HORG_Record;
  stdcall;

function OrgAPITaskInsert(
  hOrgFile: HORG_File; hOrgSect: HORG_Section;
  var RecTask: TORGTASK): HORG_Record;
  stdcall;


{ Returns a ORGAPIRET: }

function OrgAPIRecordClose(
  hOrgRec: HORG_Record): ORGAPIRET;
  stdcall;

function OrgAPIRecordDelete(
  hOrgRec: HORG_Record): ORGAPIRET;
  stdcall;

function OrgAPIRecordLinked(
  hOrgRec: HORG_Record): Longint;
  stdcall;

function OrgAPIRecordPosition(
  hOrgRec: HORG_Record): Longint;
  stdcall;

function OrgAPIAlarmGetAlarmUniqID(
  hOrgRec: HORG_Record;
  var AlarmUniqID: TORGUNIQID): ORGAPIRET;
  stdcall;

function OrgAPIAlarmGetHost(
  hOrgRec: HORG_Record; HostSectName: PChar;
  LenHostSectName: Integer; var RecordUniqID: TORGUNIQID): ORGAPIRET;
  stdcall;


{ Organizer Field Routines }

function OrgAPIFieldEnumAlt(
  hOrgSect: HORG_Section; var FieldNumber: Integer;
  FieldName: PChar; LenFieldName: Integer): ORGAPIRET;
  stdcall;

function OrgAPIFieldGetFieldCount(
  hOrgSect: HORG_Section): Longint;
  stdcall;

function OrgAPIFieldGet(
  hOrgRec: HORG_Record; FieldNumber: Integer): Pointer;
  stdcall;

function OrgAPIFieldGetFieldType(
  hOrgSect: HORG_Section;
  FieldNumber: Integer): ORGFieldType;
  stdcall;

function OrgAPIFieldIsIndexed(
  hOrgSect: HORG_Section;
  FieldNumber: Integer): Longint;
  stdcall;

function OrgAPIFieldUpdate(
  hOrgRec: HORG_Record; FieldNumber: Integer;
  FieldSize: Integer; var UserData: Pointer): ORGAPIRET;
  stdcall;


{ Organizer Error & Integer Message Routines }

function OrgAPIVersion(
  InfoBuffer: PChar; LenInfoBuffer: Integer): ORGAPIRET;
  stdcall;

function OrgAPIGetRegInfo(
  RegInfoNum: Integer; InfoBuffer: PChar;
  LenInfoBuffer: Integer): ORGAPIRET;
  stdcall;

procedure OrgAPIUIHandleErrorAlt(
  hOrgAPI: HORG_Session; InfoBuffer: PChar;
  LenInfoBuffer: Integer);
  stdcall;

function OrgAPIScriptAddr(
  var AnyType: Pointer): ORGAPIRET;
  stdcall;

function OrgAPIStringListLength(
  Pointer2StringList: Pointer): Longint;
  stdcall;

function OrgAPIGetErrorCode: Longint;
  stdcall;

{$ENDIF DynamicLinkDLL}

function GetErrorString: string;

implementation


function GetErrorString: string;
var
  Err: Longint;
  Severity: string;
  Sev: Longint;
  Facility: string;
  Fac: Longint;
  ErrCode: Longint;
begin
  Err := OrgAPIGetErrorCode;
{ Extract severity: }
  Sev := Err And $80000000;
  if (Sev = $80000000) then
    Severity := 'Failure'
  else
    Severity := 'Success';
{ Extract Facility: }
  Fac := Err And $7FF0000;
  Fac := Fac div 65535;
  if (Fac = 99) then
    Facility := 'Organizer'
  else
    Facility := '';
{ Extract Error Code: }
  ErrCode := Err And 65535;
{ Return Text for Error Code: }
  case ErrCode of
    ORGAPIEV_Success:
      result := Severity + ': Normal function termination.';
    ORGAPIEV_Failure:
      result := Severity + ': Failure';
    ORGAPIEV_OutOfDisk:
      result := Severity + ': OutOfDisk';
    ORGAPIEV_OutOfLocalMemory:
      result := Severity + ': OutOfLocalMemory';
    ORGAPIEV_OutOfGlobalMemory:
      result := Severity + ': OutOfGlobalMemory';
    ORGAPIEV_UserError:
      result := Severity + ': UserError';
    ORGAPIEV_GDIError:
      result := Severity + ': GDIError';
    ORGAPIEV_FileLocked:
      result := Severity + ': FileLocked';
    ORGAPIEV_RecordLocked:
      result := Severity + ': RecordLocked';
    ORGAPIEV_BadParms:
      result := Severity + ': BadParms';
    ORGAPIEV_Cancel:
      result := Severity + ': Cancel';
    ORGAPIEV_Retry:
      result := Severity + ': Retry';
    ORGAPIEV_Abort:
      result := Severity + ': Abort';
    ORGAPIEV_UserTerminatedProcess:
      result := Severity + ': UserTerminatedProcess';
    ORGAPIEV_AssertionFailure:
      result := Severity + ': AssertionFailure';
    ORGAPIEV_StageFailure:
      result := Severity + ': StageFailure';
    ORGAPIEV_FileCreationError:
      result := Severity + ': FileCreationError';
    ORGAPIEV_ClipboardAlreadyOpen:
      result := Severity + ': ClipboardAlreadyOpen';
    ORGAPIEV_NoFile:
      result := Severity + ': NoFile';
    ORGAPIEV_IntegrityFailure:
      result := Severity + ': IntegrityFailure';
    ORGAPIEV_FileExists:
      result := Severity + ': FileExists';
    ORGAPIEV_OSError:
      result := Severity + ': OSError';
    ORGAPIEV_ForceOSError:
      result := Severity + ': ForceOSError';
    ORGAPIEV_SeekFailure:
      result := Severity + ': SeekFailure';
    ORGAPIEV_ReadFailure:
      result := Severity + ': ReadFailure';
    ORGAPIEV_WriteFailure:
      result := Severity + ': WriteFailure';
    ORGAPIEV_MediaFailure:
      result := Severity + ': MediaFailure';
    ORGAPIEV_FreeListFailure:
      result := Severity + ': FreeListFailure';
    ORGAPIEV_YearRange:
      result := Severity + ': YearRange';
    ORGAPIEV_MonthRange:
      result := Severity + ': MonthRange';
    ORGAPIEV_DayRange:
      result := Severity + ': DayRange';
    ORGAPIEV_HourRange:
      result := Severity + ': HourRange';
    ORGAPIEV_MinuteRange:
      result := Severity + ': MinuteRange';
    ORGAPIEV_StructSizeError:
      result := Severity + ': StructSizeError';
    ORGAPIEV_StructPaddingError:
      result := Severity + ': StructPaddingError';
    ORGAPIEV_StructMemberMisAligned:
      result := Severity + ': StructMemberMisAligned';
    ORGAPIEV_StructMemberCountError:
      result := Severity + ': StructMemberCountError';
    ORGAPIEV_KernelError:
      result := Severity + ': KernelError';
    ORGAPIEV_ExecuteError:
      result := Severity + ': ExecuteError';
    ORGAPIEV_BadDataPtr:
      result := Severity + ': BadDataPtr';
    ORGAPIEV_BadCodePtr:
      result := Severity + ': BadCodePtr';
    ORGAPIEV_StringNonExistant:
      result := Severity + ': StringNonExistant';
    ORGAPIEV_NotVirtualFile:
      result := Severity + ': NotVirtualFile';
    ORGAPIEV_NoTable:
      result := Severity + ': NoTable';
    ORGAPIEV_AccessViolation:
      result := Severity + ': AccessViolation';
    ORGAPIEV_BadID:
      result := Severity + ': BadID';
    ORGAPIEV_ReadPastEOF:
      result := Severity + ': ReadPastEOF';
    ORGAPIEV_FieldNameExists:
      result := Severity + ': FieldNameExists';
    ORGAPIEV_NetworkDirectoryError:
      result := Severity + ': NetworkDirectoryError';
    ORGAPIEV_NetworkTransportError:
      result := Severity + ': NetworkTransportError';
    ORGAPIEV_NetworkNetDLLError:
      result := Severity + ': NetworkNetDLLError';
    ORGAPIEV_EndOfTable:
      result := Severity + ': EndOfTable';
    ORGAPIEV_InvalidVirtualFile:
      result := Severity + ': InvalidVirtualFile';
    ORGAPIEV_CommDlgError:
      result := Severity + ': CommDlgError';
    ORGAPIEV_NoNamedFile:
      result := Severity + ': NoNamedFile';
    ORGAPIEV_BadMessage:
      result := Severity + ': BadMessage';
    ORGAPIEV_Timeout:
      result := Severity + ': Timeout';
    ORGAPIEV_UnexpectedCommError:
      result := Severity + ': UnexpectedCommError';
    ORGAPIEV_BadOrs:
      result := Severity + ': BadOrs';
    ORGAPIEV_DuplicateValueInField:
      result := Severity + ': DuplicateValueInField';
    ORGAPIEV_ForcedFailure:
      result := Severity + ': ForcedFailure';
    ORGAPIEV_NotLocked:
      result := Severity + ': NotLocked';
    ORGAPIEV_GPFault:
      result := Severity + ': GPFault';
    ORGAPIEV_Organizer1File:
      result := Severity + ': Organizer1File';
    ORGAPIEV_UserBreak:
      result := Severity + ': UserBreak';
    ORGAPIEV_DivideByZero:
      result := Severity + ': DivideByZero';
    ORGAPIEV_FreetimeError:
      result := Severity + ': FreetimeError';
    ORGAPIEV_SecondRange:
      result := Severity + ': SecondRange';
    ORGAPIEV_InvalidPlatformFile:
      result := Severity + ': InvalidPlatformFile';
    ORGAPIEV_ListBroken:
      result := Severity + ': ListBroken';
    ORGAPIEV_TreeBroken:
      result := Severity + ': TreeBroken';
    ORGAPIEV_PrivateError:
      result := Severity + ': PrivateError';
    ORGAPIEV_AlreadyInvited:
      result := Severity + ': AlreadyInvited';
    ORGAPIEV_StackOverrun:
      result := Severity + ': StackOverrun';
    ORGAPIEV_BadDIB:
      result := Severity + ': BadDIB';
    ORGAPIEV_BadMetafile:
      result := Severity + ': BadMetafile';
    ORGAPIEV_PrinterError:
      result := Severity + ': PrinterError';
    ORGAPIEV_RegDBError:
      result := Severity + ': RegDBError';
    ORGAPIEV_NoPrinterConnected:
      result := Severity + ': NoPrinterConnected';
    ORGAPIEV_IncomingCall:
      result := Severity + ': IncomingCall';
    ORGAPIEV_BufferTooSmall:
      result := Severity + ': BufferTooSmall';
    ORGAPIEV_WriteProtect:
      result := Severity + ': WriteProtect';
    ORGAPIEV_NetworkAccessDenied:
      result := Severity + ': NetworkAccessDenied';
    ORGAPIEV_LinkSelf:
      result := Severity + ': LinkSelf';
    ORGAPIEV_LinkAlready:
      result := Severity + ': LinkAlready';
    ORGAPIEV_RemoteDelete:
      result := Severity + ': RemoteDelete';
    ORGAPIEV_Warning:
      result := Severity + ': Warning';
    ORGAPIEV_TableExists:
      result := Severity + ': TableExists';
    ORGAPIEV_Org10FileCorrupt:
      result := Severity + ': Org10FileCorrupt';
    ORGAPIEV_AccessDenied:
      result := Severity + ': AccessDenied';
    ORGAPIEV_BadPath:
      result := Severity + ': BadPath';
    ORGAPIEV_BufferNotLocked:
      result := Severity + ': BufferNotLocked';
    ORGAPIEV_TableDeleted:
      result := Severity + ': TableDeleted';
    ORGAPIEV_BadInstall:
      result := Severity + ': BadInstall';
    ORGAPIEV_InvalidInput:
      result := Severity + ': InvalidInput';
    ORGAPIEV_ODBCError:
      result := Severity + ': ODBCError';
    ORGAPIEV_FieldOverflow:
      result := Severity + ': FieldOverflow';
    ORGAPIEV_DDEMLError:
      result := Severity + ': DDEMLError';
    ORGAPIEV_NotSchedulingFile:
      result := Severity + ': NotSchedulingFile';
    ORGAPIEV_BadPassword:
      result := Severity + ': BadPassword';
    ORGAPIEV_CriticalFault:
      result := Severity + ': CriticalFault';
    ORGAPIEV_OutOfLuck:
      result := Severity + ': OutOfLuck';
    ORGAPIEV_NoSchema:
      result := Severity + ': NoSchema';
    ORGAPIEV_WrongMetafileFormat:
      result := Severity + ': WrongMetafileFormat';
    ORGAPIEV_WrongBackupFilePath:
      result := Severity + ': WrongBackupFilePath';
    ORGAPIEV_OLECantCreateObject:
      result := Severity + ': OLECantCreateObject';
    ORGAPIEV_OLEPasteSpecialFailed:
      result := Severity + ': OLEPasteSpecialFailed';
    ORGAPIEV_OLEPasteLinkFailed:
      result := Severity + ': OLEPasteLinkFailed';
    ORGAPIEV_OLELinksCannotBeInitialized:
      result := Severity + ': OLELinksCannotBeInitialized';
    ORGAPIEV_OLEUpdateLinksFailed:
      result := Severity + ': OLEUpdateLinksFailed';
    ORGAPIEV_OLELinkSourceCannotBeOpened:
      result := Severity + ': OLELinkSourceCannotBeOpened';
    ORGAPIEV_OLEManageLinksFailed:
      result := Severity + ': OLEManageLinksFailed';
    ORGAPIEV_OLEObjectCannotBeAccessed:
      result := Severity + ': OLEObjectCannotBeAccessed';
    ORGAPIEV_OLEObjectCannotBeLoaded:
      result := Severity + ': OLEObjectCannotBeLoaded';
    ORGAPIEV_OLEHandlersCannotbeInitialized:
      result := Severity + ': OLEHandlersCannotbeInitialized';
    ORGAPIEV_OLECancelLinkFailed:
      result := Severity + ': OLECancelLinkFailed';
    ORGAPIEV_OLEObjectSaveFailed:
      result := Severity + ': OLEObjectSaveFailed';
    else
      result := Severity + ': Bad Error Number';
  end;
end;



{$IFDEF DynamicLinkDLL}

const
  OrgAPI32dll = 'OrgAPI32.dll';
  LibHandle: Integer = 0;


constructor EOrganizerError.Create(const Msg: string);
var
  s: string;
begin
  if (LibHandle < 32) then
  begin
    s := Msg;
    if (s <> '') then
    begin
      if (s[Length(s)] = '.') then
        s[Length(s)] := ':'
      else
        if (s[Length(s)] <> ':') then
          s := s + ':';
      s := s + #10;
    end;
    s := s + 'OrgAPI32.dll is not loaded';
    inherited Create(s);
  end
  else
  begin
    s := Msg;
    if (s <> '') then
    begin
      if (s[Length(s)] = '.') then
        s[Length(s)] := ':'
      else
        if (s[Length(s)] <> ':') then
          s := s + ':';
      s := s + #10;
    end;
    s := s + GetErrorString;
    inherited Create(s);
  end;
end;


function GetRegisteredDir(const SubKey, ValueName: string): string;
var
  Key: HKey;
  Value: array[0..255] of Char;
  SizeOfValue: Longint;
  Err: Integer;
  DataType: Integer;
begin
  result := '';
  if not (RegOpenKeyEx(HKEY_CURRENT_USER, PChar(SubKey),
                       0, KEY_READ, Key) = ERROR_SUCCESS) then
    exit;
  SizeOfValue := SizeOf(Value);
  Err := RegQueryValueEx(Key, PChar(ValueName), nil, @DataType,
                         PByte(@Value), @SizeOfValue);
  if (Err = ERROR_SUCCESS) then
  begin
    result := Value;
    if (Value[StrLen(Value) -1] <> '\') then
      result := result + '\';
  end;
end;

const
  LotusComponentDllCount = 3;

type
  TLotusComponentDlls = array [1..LotusComponentDllCount] of
    record
      DllName: string[15];
      LibHandle: Integer;
    end;

const
  LotusComponentDlls: TLotusComponentDlls =
   ((DllName: 'LTSCSN10.DLL'; LibHandle: 0),
    (DllName: 'LTASWN14.DLL'; LibHandle: 0),
    (DllName: 'LTASBN14.DLL'; LibHandle: 0));

function LoadOrgAPI32: Boolean;
var
  s: string;
  CurrentDir: string;
  OrgComponentDir: string;
  i: Integer;
begin
  result := false;
{ Load some DLL's that are not in the Organizer-directory so that they can be
  found by OrgAPI32.dll in memory: }
  OrgComponentDir := GetRegisteredDir('Software\Lotus\Components', 'User Path');
  for i := 1 to LotusComponentDllCount do
  begin
    s := OrgComponentDir + LotusComponentDlls[i].DllName;
    LotusComponentDlls[i].LibHandle := LoadLibrary(PChar(s));
  end;
{ OrgAPI32.dll loads TZNET32.DLL, tziso32.dll, TZBACK32.dll and others
  that are in the Organizer-directory: }
  CurrentDir := GetCurrentDir;
  SetCurrentDir(GetRegisteredDir(
    'Software\Lotus\Organizer\97.0\Settings', 'OrgHomeDir'));
  LibHandle := LoadLibrary(OrgAPI32dll);
  SetCurrentDir(CurrentDir);
{ s := OrgHomeDir + OrgAPI32dll;
  LibHandle := LoadLibraryEx(PChar(s), 0, LOAD_WITH_ALTERED_SEARCH_PATH);
  ... does not work. Did I misunderstood LOAD_WITH_ALTERED_SEARCH_PATH ? }
{ We do not need them no more, they are referenced by OrgAPI32.dll now: }
  for i := 1 to LotusComponentDllCount do
  begin
    if (LotusComponentDlls[i].LibHandle >= 32) then
      FreeLibrary(LotusComponentDlls[i].LibHandle);
  end;
  if (LibHandle < 32) then
  begin { error: }
    exit;
  end;
  @OrgAPIInit := GetProcAddress(LibHandle, 'OrgAPIInit');
  @OrgAPITerm := GetProcAddress(LibHandle, 'OrgAPITerm');
  @OrgAPIFileOpen := GetProcAddress(LibHandle, 'OrgAPIFileOpen');
  @OrgAPIFileClose := GetProcAddress(LibHandle, 'OrgAPIFileClose');
  @OrgAPIFileGetPrivilege := GetProcAddress(LibHandle, 'OrgAPIFileGetPrivilege');
  @OrgAPIDBGetSingleUser := GetProcAddress(LibHandle, 'OrgAPIDBGetSingleUser');
  @OrgAPIDBSetSingleUser := GetProcAddress(LibHandle, 'OrgAPIDBSetSingleUser');
  @OrgAPIEnumerateSectionsAlt := GetProcAddress(LibHandle, 'OrgAPIEnumerateSectionsAlt');
  @OrgAPISectionOpen := GetProcAddress(LibHandle, 'OrgAPISectionOpen');
  @OrgAPISectionClose := GetProcAddress(LibHandle, 'OrgAPISectionClose');
  @OrgAPISectionClass := GetProcAddress(LibHandle, 'OrgAPISectionClass');
  @OrgAPISectionGetPrivilege := GetProcAddress(LibHandle, 'OrgAPISectionGetPrivilege');
  @OrgAPISectionType := GetProcAddress(LibHandle, 'OrgAPISectionType');
  @OrgAPISectionRecordCount := GetProcAddress(LibHandle, 'OrgAPISectionRecordCount');
  @OrgAPISectionAlphaSearchAlt := GetProcAddress(LibHandle, 'OrgAPISectionAlphaSearchAlt');
  @OrgAPIIsUNIQIDDeleted := GetProcAddress(LibHandle, 'OrgAPIIsUNIQIDDeleted');
  @OrgAPIRecordOpen := GetProcAddress(LibHandle, 'OrgAPIRecordOpen');
  @OrgAPIRecordFindFirst := GetProcAddress(LibHandle, 'OrgAPIRecordFindFirst');
  @OrgAPIRecordFindNext := GetProcAddress(LibHandle, 'OrgAPIRecordFindNext');
  @OrgAPIRecordOpenByUniqID := GetProcAddress(LibHandle, 'OrgAPIRecordOpenByUniqID');
  @OrgAPIAddressInsert := GetProcAddress(LibHandle, 'OrgAPIAddressInsert');
  @OrgAPIAlarmInsert := GetProcAddress(LibHandle, 'OrgAPIAlarmInsert');
  @OrgAPIAnniversaryInsert := GetProcAddress(LibHandle, 'OrgAPIAnniversaryInsert');
  @OrgAPIAppointmentInsert := GetProcAddress(LibHandle, 'OrgAPIAppointmentInsert');
  @OrgAPICallInsert := GetProcAddress(LibHandle, 'OrgAPICallInsert');
  @OrgAPINotePadInsert := GetProcAddress(LibHandle, 'OrgAPINotePadInsert');
  @OrgAPIPlannerInsert := GetProcAddress(LibHandle, 'OrgAPIPlannerInsert');
  @OrgAPITaskInsert := GetProcAddress(LibHandle, 'OrgAPITaskInsert');
  @OrgAPIRecordClose := GetProcAddress(LibHandle, 'OrgAPIRecordClose');
  @OrgAPIRecordDelete := GetProcAddress(LibHandle, 'OrgAPIRecordDelete');
  @OrgAPIRecordLinked := GetProcAddress(LibHandle, 'OrgAPIRecordLinked');
  @OrgAPIRecordPosition := GetProcAddress(LibHandle, 'OrgAPIRecordPosition');
  @OrgAPIAlarmGetAlarmUniqID := GetProcAddress(LibHandle, 'OrgAPIAlarmGetAlarmUniqID');
  @OrgAPIAlarmGetHost := GetProcAddress(LibHandle, 'OrgAPIAlarmGetHost');
  @OrgAPIFieldEnumAlt := GetProcAddress(LibHandle, 'OrgAPIFieldEnumAlt');
  @OrgAPIFieldGetFieldCount := GetProcAddress(LibHandle, 'OrgAPIFieldGetFieldCount');
  @OrgAPIFieldGet := GetProcAddress(LibHandle, 'OrgAPIFieldGet');
  @OrgAPIFieldGetFieldType := GetProcAddress(LibHandle, 'OrgAPIFieldGetFieldType');
  @OrgAPIFieldIsIndexed := GetProcAddress(LibHandle, 'OrgAPIFieldIsIndexed');
  @OrgAPIFieldUpdate := GetProcAddress(LibHandle, 'OrgAPIFieldUpdate');
  @OrgAPIVersion := GetProcAddress(LibHandle, 'OrgAPIVersion');
  @OrgAPIGetRegInfo := GetProcAddress(LibHandle, 'OrgAPIGetRegInfo');
  @OrgAPIUIHandleErrorAlt := GetProcAddress(LibHandle, 'OrgAPIUIHandleErrorAlt');
  @OrgAPIScriptAddr := GetProcAddress(LibHandle, 'OrgAPIScriptAddr');
  @OrgAPIStringListLength := GetProcAddress(LibHandle, 'OrgAPIStringListLength');
  @OrgAPIGetErrorCode := GetProcAddress(LibHandle, 'OrgAPIGetErrorCode');
  result := true;
end;

{ Dummys are called if OrgAPI32.dll is not loaded: }
function Dummy2(P1, P2: Longint): Longint; stdcall;
begin  result := OA_FAILURE; end;

function Dummy6(P1, P2, P3, P4, P5, P6: Longint): Longint; stdcall;
begin result := OA_FAILURE; end;

function DummyOrgAPIInit(hWndForm: HWND; Zero1, Zero2, Zero3: Integer;
  ContainerPath, Name, Password: PChar; ApiInitFlags: Integer;
  var Err: Integer): HORG_Session; stdcall;
begin
  if LoadOrgAPI32 then
    result := OrgAPIInit(hWndForm, Zero1, Zero2, Zero3, ContainerPath, Name,
                         Password, ApiInitFlags, Err)
  else
    result := OA_FAILURE;
end;

procedure InitOrgAPI;
begin
  @OrgAPIInit := @DummyOrgAPIInit;
  @OrgAPIVersion := @Dummy2;
  @OrgAPIFileOpen := @Dummy6;
  @OrgAPISectionOpen := @Dummy2;
  @OrgAPIRecordOpen := @Dummy2;
end;

{$ELSE DynamicLinkDLL ------------------------------------------------------- }

constructor EOrganizerError.Create(const Msg: string);
begin
  inherited Create(Msg);
end;

function OrgAPIInit; external 'OrgAPI32.dll';
function OrgAPITerm; external 'OrgAPI32.dll';
function OrgAPIFileOpen; external 'OrgAPI32.dll';
function OrgAPIFileClose; external 'OrgAPI32.dll';
function OrgAPIFileGetPrivilege; external 'OrgAPI32.dll';
function OrgAPIDBGetSingleUser; external 'OrgAPI32.dll';
function OrgAPIDBSetSingleUser; external 'OrgAPI32.dll';
function OrgAPIEnumerateSectionsAlt; external 'OrgAPI32.dll';
function OrgAPISectionOpen; external 'OrgAPI32.dll';
function OrgAPISectionClose; external 'OrgAPI32.dll';
function OrgAPISectionClass; external 'OrgAPI32.dll';
function OrgAPISectionGetPrivilege; external 'OrgAPI32.dll';
function OrgAPISectionType; external 'OrgAPI32.dll';
function OrgAPISectionRecordCount; external 'OrgAPI32.dll';
function OrgAPISectionAlphaSearchAlt; external 'OrgAPI32.dll';
function OrgAPIIsUNIQIDDeleted; external 'OrgAPI32.dll';
function OrgAPIRecordOpen; external 'OrgAPI32.dll';
function OrgAPIRecordFindFirst; external 'OrgAPI32.dll';
function OrgAPIRecordFindNext; external 'OrgAPI32.dll';
function OrgAPIRecordOpenByUniqID; external 'OrgAPI32.dll';
function OrgAPIAddressInsert; external 'OrgAPI32.dll';
function OrgAPIAlarmInsert; external 'OrgAPI32.dll';
function OrgAPIAnniversaryInsert; external 'OrgAPI32.dll';
function OrgAPIAppointmentInsert; external 'OrgAPI32.dll';
function OrgAPICallInsert; external 'OrgAPI32.dll';
function OrgAPINotePadInsert; external 'OrgAPI32.dll';
function OrgAPIPlannerInsert; external 'OrgAPI32.dll';
function OrgAPITaskInsert; external 'OrgAPI32.dll';
function OrgAPIRecordClose; external 'OrgAPI32.dll';
function OrgAPIRecordDelete; external 'OrgAPI32.dll';
function OrgAPIRecordLinked; external 'OrgAPI32.dll';
function OrgAPIRecordPosition; external 'OrgAPI32.dll';
function OrgAPIAlarmGetAlarmUniqID; external 'OrgAPI32.dll';
function OrgAPIAlarmGetHost; external 'OrgAPI32.dll';
function OrgAPIFieldEnumAlt; external 'OrgAPI32.dll';
function OrgAPIFieldGetFieldCount; external 'OrgAPI32.dll';
function OrgAPIFieldGet; external 'OrgAPI32.dll';
function OrgAPIFieldGetFieldType; external 'OrgAPI32.dll';
function OrgAPIFieldIsIndexed; external 'OrgAPI32.dll';
function OrgAPIFieldUpdate; external 'OrgAPI32.dll';
function OrgAPIVersion; external 'OrgAPI32.dll';
function OrgAPIGetRegInfo; external 'OrgAPI32.dll';
procedure OrgAPIUIHandleErrorAlt; external 'OrgAPI32.dll';
function OrgAPIScriptAddr; external 'OrgAPI32.dll';
function OrgAPIStringListLength; external 'OrgAPI32.dll';
function OrgAPIGetErrorCode; external 'OrgAPI32.dll';

{$ENDIF DynamicLinkDLL}

{$IFDEF DynamicLinkDLL}
initialization
  InitOrgAPI;
{  LoadOrgAPI32; }
{ if not LoadOrgAPI32 then
    raise Exception.Create('Unable to load OrgAPI32.dll'); {}
finalization
  if LibHandle >= 32 then
    FreeLibrary(LibHandle);
{$ENDIF DynamicLinkDLL}
end.
