unit TestPxAddrToOrgForm;

{ $DEFINE German} { Different section-names }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, DB, StdCtrls, Buttons, ComCtrls, Organizer, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    OSession1: TOSession;
    OFile1: TOFile;
    OSection1: TOSection;
    ORecord1: TORecord;
    Label1: TLabel;
    ProgressBar1: TProgressBar;
    bbtnStart: TBitBtn;
    bbtnClose: TBitBtn;
    Table1LAST_NAME: TStringField;
    Table1FIRST_NAME: TStringField;
    Table1ACCT_NBR: TFloatField;
    Table1ADDRESS_1: TStringField;
    Table1CITY: TStringField;
    Table1STATE: TStringField;
    Table1ZIP: TStringField;
    Table1TELEPHONE: TStringField;
    Table1DATE_OPEN: TDateField;
    Table1SS_NUMBER: TFloatField;
    Table1PICTURE: TStringField;
    Table1BIRTH_DATE: TDateField;
    Table1RISK_LEVEL: TStringField;
    Table1OCCUPATION: TStringField;
    Table1OBJECTIVES: TStringField;
    Table1INTERESTS: TStringField;
    procedure bbtnStartClick(Sender: TObject);
    procedure bbtnCloseClick(Sender: TObject);
  private
    Stopped: Boolean;
    procedure DeleteAll;
    procedure CopyToOrg;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  OrgApi;

procedure TForm1.DeleteAll;
begin
  Label1.Caption := 'Deleting old addresses';
  Application.ProcessMessages;
  ProgressBar1.Position := ProgressBar1.Min;
  ProgressBar1.Max := ORecord1.RecordCount;
  while (not Stopped) and (ORecord1.RecordCount > 0) do
  begin
    try
      ORecord1.Delete;
    except
      ORecord1.Close;
      OSection1.Close;
      OSection1.Open;
      ORecord1.Open;
      ORecord1.Next;
    end;
    ProgressBar1.StepIt;
    Application.ProcessMessages;
  end;
  if Stopped then
    Label1.Caption := 'Deletion stopped'
  else
    Label1.Caption := 'Deletion done';
  Application.ProcessMessages;
end;

procedure TForm1.CopyToOrg;
const
  CrLf = #13 + #10;
var
  s: String;
  i: Integer;
begin
  with ORecord1 do
  begin
    Insert;
{   Fields[ORGADDR_TITLE].Text := 'Mr.'; }
    Fields[ORGADDR_LNAME].Text := Trim(Table1LAST_NAME.AsString);
    Fields[ORGADDR_FNAME].Text := Trim(Table1FIRST_NAME.AsString);
{   Fields[ORGADDR_COMPANY].Text := ?; {}
    Fields[ORGADDR_POSITION].Text := Trim(Table1OCCUPATION.AsString);
    Fields[ORGADDR_CATEGORY].Text := 'Test';
    Fields[ORGADDR_HOME_ADDRESS].Text := Table1ADDRESS_1.AsString;
    Fields[ORGADDR_HOME_ZIP].Text := Table1ZIP.AsString;
    Fields[ORGADDR_HOME_CITY].Text := Table1CITY.AsString;
{   Fields[ORGADDR_HOME_COUNTRY].Text := ?; }
    Fields[ORGADDR_HOME_STATE].Text := Table1STATE.AsString;
    if (Table1INTERESTS.AsString <> '') then
      s := 'Interests: ' + Table1INTERESTS.AsString
    else
      s := '';
    if (Table1OBJECTIVES.AsString <> '') then
      if (s <> '') then
        s := s + CrLf + 'Objectives: ' + Table1OBJECTIVES.AsString
      else
        s := 'Objectives: ' + Table1OBJECTIVES.AsString;
    Fields[ORGADDR_HOME_NOTES].Text := s;
    Fields[ORGADDR_HOME_PHONE].Text := Table1TELEPHONE.AsString;
    Post;
  end;
end;



procedure TForm1.bbtnStartClick(Sender: TObject);
var
  Counter: Integer;
begin
  if (bbtnStart.Caption = 'Stop') then
  begin
    Stopped := true;
    exit;
  end;
{$IFDEF German}
  OSection1.SectionName := 'Adressen'; { German file }
{$ELSE DEF German}
  OSection1.SectionName := 'Address'; { Us-English file }
{$ENDIF DEF German}
  ProgressBar1.Position := ProgressBar1.Min;
  Label1.Caption := 'Opening Organizer';
  Application.ProcessMessages;
  try
    OSession1.Open;
    if (Pos('\', OFile1.FileName) = 0) then { if no path add Exe-path: }
      OFile1.FileName := ExtractFilePath(Application.ExeName) + OFile1.FileName;
    Label1.Caption := 'Opening ' + OFile1.FileName;
    Application.ProcessMessages;
    OFile1.Open;
    OSection1.Open;
    ORecord1.Open;
{
    Label1.Caption := 'Opening table';
    Application.ProcessMessages;
    Table1.Open;
}
    bbtnStart.Caption := 'Stop';
    Stopped := false;
    DeleteAll;  {}
    if not Stopped then
    begin
      ProgressBar1.Position := 0;
      Counter := 0;
      Application.ProcessMessages;
      with Table1 do
      begin
        ProgressBar1.Max := RecordCount;
        while (not Stopped) and not EOF do
        begin
          Inc(Counter);
          Label1.Caption := 'Adding address no.: ' + IntToStr(Counter);
          ProgressBar1.StepIt;
          Application.ProcessMessages;
          CopyToOrg;
          Next;
          Application.ProcessMessages;
        end;
      end;
      if Stopped then
        Label1.Caption := 'Stopped at address no.: ' + IntToStr(Counter)
      else
        Label1.Caption := 'Done';
    end;
  finally
    Stopped := false;
    bbtnStart.Caption := 'Start';
    Application.ProcessMessages;
{   Table1.Close; {}
    ORecord1.Close;
    OSection1.Close;
    OFile1.Close;
    OSession1.Close;
  end;
end;

procedure TForm1.bbtnCloseClick(Sender: TObject);
begin
  Close;
end;

end.
